#include "DataTable.h"

DataTable::DataTable(const char InputFileName[]) {
	using namespace std;

	int v;				// this is a loop index variable
	string VarNameIn;	// place to put each variable name as read
	char next;			// a character variable to pick up line-ends
	RowVector DataLineIn;	// temp storage for a line of data
	
	ifstream InputFile(InputFileName, ios::in);	// this opens the input file
						// hereafter it is referred to as InputFile
	nVars = 1;			// initialize nVars to 1 (to count them,
	InputFile >> VarNameIn;	// which we'll do by counting variable names
	VarNames.push_back(VarNameIn);  // "push" the first VarnameIn onto Varnames
	do {							// (being able to do that is a vector property)
		nVars++;					// increment nVars
		InputFile >> VarNameIn;		// read the next (white-space delimited) VarNameIn
		VarNames.push_back(VarNameIn);  // and push it onto VarNames
		InputFile.get(next);		// peek ahead: is the next character \n ?
	} while (next != '\n');			// if it is, end of line and we're done
	
	DataLineIn.ReSize(nVars);	// ReSize (a property of RowVectors) to nVars
	N = 0;						// initialize N to count rows of the data table
	Data.ReSize(1,nVars); 		// ReSize the Data matrix to accept the first row
	do {
		N++;					// increment N for each line read
		for (v = 1; v <= nVars; v++) {	// loop over nVars variables
 			InputFile >> DataLineIn(v);	// each number successively into DataLineIn
		}
	if (N > 1) {		// if it after the first line, 
		Data.Release(); 			// these four lines
		Matrix LocalData = Data; 	// copy what's in Data so far into LocalData,
		Data.ReSize(N,nVars); 		// and then add a line to Data
		Data.Rows(1,(N-1))=LocalData;	// and copy what we had already back
		}
	Data.Row(N) = DataLineIn;	// now add the currently-read line to Data
	} while (!InputFile.eof());	// until we encounter the end of file---eof()---
}				// eof() is a function of the class ifstream that returns T if the next
				// character is the end of file
				
DataTable::~DataTable() {
// null destructor; simply must be here but does nothing in this case
}