/*
 *  Probit C++
 */

#include "DataTable.h"			// DataTable.h defines the DataTable class (ours)
#include "ProbitRegression.h"		// PolyRegression.h defines the PolyRegression class (ours)

int main() {					// the "main" routine is typed int, returns 0 upon success
	using namespace std;		// namespace std is now conventional in C++ code

	char InputFileName[255]; 	// this is the space for the InputFileName (255 chars max)
	int v;						// this is a loop index variable

	cout << "Enter Data File Name: ";	// cout is 'Console OUTput'
	cin.getline(InputFileName, 255);	// cin is 'Console INput'; its getline routine reads
										// the (rest of the) input line; ans: Table4-1.dat
	DataTable TheTable(InputFileName);	// the DataTable constructor creates TheTable
										// and fills it with data from InputFileName
	cout << TheTable.N << " observations read for" << endl;			// these lines
	cout << TheTable.nVars << " variables; the data are:" << endl;	// write back to console
	for (v = 0; v < TheTable.nVars; v++) {							// the data
		cout << TheTable.VarNames[v] << "\t";						// as they were read
	}
	cout  << endl;						// N, nVars, VarNames, and Data are Public
	cout << TheTable.Data;				// components of TheTable
	cout << endl;						// endl is a line-end

	ProbitRegression(TheTable);		// does Probit fitting (in ProbitRegression.cp)

	return 0;
}